<?php

// Some WP 1.3 functions

if(!isset($wpdb->posts))
{
	$wpdb->posts               = $table_prefix . 'posts';
	$wpdb->users               = $table_prefix . 'users';
	$wpdb->categories          = $table_prefix . 'categories';
	$wpdb->post2cat            = $table_prefix . 'post2cat';
	$wpdb->comments            = $table_prefix . 'comments';
	$wpdb->links               = $table_prefix . 'links';
	$wpdb->linkcategories      = $table_prefix . 'linkcategories';
	$wpdb->options             = $table_prefix . 'options';
	$wpdb->optiontypes         = $table_prefix . 'optiontypes';
	$wpdb->optionvalues        = $table_prefix . 'optionvalues';
	$wpdb->optiongroups        = $table_prefix . 'optiongroups';
	$wpdb->optiongroup_options = $table_prefix . 'optiongroup_options';
	$wpdb->postmeta            = $table_prefix . 'postmeta';
}

if (!function_exists('wp_insert_post')) {
function wp_insert_post($postarr = array()) {
        global $wpdb, $post_default_category;
        
        // export array as variables
        extract($postarr);
        
        // Do some escapes for safety
        $post_title = $wpdb->escape($post_title);
        $post_name = sanitize_title($post_title);
        $post_excerpt = $wpdb->escape($post_excerpt);
        $post_content = $wpdb->escape($post_content);
        $post_author = (int) $post_author;
        
        // Make sure we set a valid category
        if (0 == count($post_category) || !is_array($post_category)) {
                $post_category = array($post_default_category);
        }

        $post_cat = $post_category[0];

        if (empty($post_date))
                $post_date = current_time('mysql');
        // Make sure we have a good gmt date:
        if (empty($post_date_gmt)) 
                $post_date_gmt = get_gmt_from_date($post_date);
        
        $sql = "INSERT INTO $wpdb->posts
                 (post_author, post_date, post_date_gmt, post_modified, post_modified_gmt, post_content, post_title, post_excerpt, post_category, post_status, post_name, post_lat, post_lon, post_parent)
                 VALUES ('$post_author', '$post_date', '$post_date_gmt', '$post_date', '$post_date_gmt', '$post_content', '$post_title', '$post_excerpt', '$post_cat', '$post_status', '$post_name', '$post_lat', '$post_lon', '$post_parent')";

        $result = $wpdb->query($sql);
        $post_ID = $wpdb->insert_id;

        wp_set_post_cats('',$post_ID,$post_category);

        if ($post_status == 'publish') {
                do_action('publish_post', $post_ID);
        }        // Return insert_id if we got a good result, otherwise return zero.
        return $result ? $post_ID : 0;}
}

if (!function_exists('wp_get_single_post')) {
function wp_get_single_post($postid = 0, $mode = OBJECT) {
        global $wpdb;
        
        $sql = "SELECT * FROM $wpdb->posts WHERE ID=$postid";
        $result = $wpdb->get_row($sql, $mode);

        // Set categories
        $result['post_category'] = wp_get_post_cats('',$postid);
        
        return $result;
}
}

if (!function_exists('wp_get_post_cats')) {
function wp_get_post_cats($blogid = '1', $post_ID = 0) {
        global $wpdb;

        $sql = "SELECT category_id
                FROM $wpdb->post2cat
                WHERE post_id = $post_ID
                ORDER BY category_id";

        $result = $wpdb->get_col($sql);

        return array_unique($result);
}
}

if (!function_exists('wp_set_post_cats')) {
function wp_set_post_cats($blogid = '1', $post_ID = 0, $post_categories = array()) {
        global $wpdb;
        // If $post_categories isn't already an array, make it one:
        if (!is_array($post_categories)) {
                if (!$post_categories) { 
                        $post_categories = 1;
                }
                $post_categories = array($post_categories);
        }

        $post_categories = array_unique($post_categories);

        // First the old categories
        $old_categories = $wpdb->get_col("
                SELECT category_id
                FROM $wpdb->post2cat
                WHERE post_id = $post_ID");

        if (!$old_categories) {
                $old_categories = array();
        } else {
                $old_categories = array_unique($old_categories);
        }

        // Delete any? 
        $delete_cats = array_diff($old_categories,$post_categories);
        
        if ($delete_cats) {
                foreach ($delete_cats as $del) {
                        $wpdb->query(" 
                                DELETE FROM $wpdb->post2cat
                                WHERE category_id = $del 
                                        AND post_id = $post_ID
                                ");
                }
        }

        // Add any?
        $add_cats = array_diff($post_categories, $old_categories);

        if ($add_cats) {
                foreach ($add_cats as $new_cat) {
                        $wpdb->query("
                                INSERT INTO $wpdb->post2cat (post_id, category_id)
                                VALUES ($post_ID, $new_cat)");

		}
        }
}       // wp_set_post_cats()
}

if (!function_exists('wp_delete_post')) {
function wp_delete_post($postid = 0) {
        global $wpdb;

        $sql = "DELETE FROM $wpdb->post2cat WHERE post_id = $postid";
        $wpdb->query($sql);

        $sql = "DELETE FROM $wpdb->posts WHERE ID = $postid";

        $wpdb->query($sql);

        $result = $wpdb->rows_affected;

        return $result;
}
}

if (!function_exists('is_single')) {
function is_single() {
	global $posts, $single;

	return $single || count($posts) == 1;
}
}

?>
